//+------------------------------------------------------------------+
//|                                                       152806.mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#property strict
#include <Arrays\ArrayDouble.mqh>

#define STDDEV "STDDEV"
#define SDNAME(t0) STDDEV+(string)t0
//string obj_name = "SL_DEV";
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
enum TP_MODE
  {
   TP_MODE_NONE,
   TP_MODE_STD_PERCENT
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
enum SL_MODE
  {
   SL_MODE_NONE,
   SL_MODE_TP,
   SL_MODE_STD
  };

input double lotsize=1;
input int max_slippage=5;
input TP_MODE takeprofit_mode=TP_MODE_STD_PERCENT;
input double secondary_tp_mult=2;
//input double fallback_tp_mult=2;
input double takeprofit_percent=15;
input SL_MODE stoploss_mode=SL_MODE_STD;
input double secondary_sl_mult=2;
//input double fallback_sl_mult=2;
input double stoploss_deviation=8;

string LotHedging="0.1,0.2,0.3";
enum tsltp2{normal,multiple};
input tsltp2 TP2Order=1;
input tsltp2 SL2Order=1;
input double TP_2=2;
input double SL_2=2;
input bool Direction = false;
input bool Reverse_Direction = true;
input double LotHed=1;
input string day_start="00:00";
input string day_end="23:59";
input int channel_min=60;
input int order_time_distance_min=30;
input double std_deviation=4;
input color std_color=clrGreen;
input ENUM_LINE_STYLE std_style=STYLE_SOLID;
input int std_width = 1;
input bool std_back = false;
input bool email_enabled = false;
input bool alert_enabled = true;
input int magic_number=12345;
input int magic_number_hedging=56789;
int last_ticket, Order_Type;
string last_channel;
double lv[];
string subject="Channel breached: "+Symbol();
//string comment;
//string last_trade_comment;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   if(!IsTesting())
      ObjectsDeleteAll(0,-1,OBJ_STDDEVCHANNEL);
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
string ceks;int atik;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CutS()
  {
   int s=0;
   ceks=ceks+"\n langkah "+(string)s;s++;
   double tlot=0,top[2]={0,0},pric[2]={0,0};
   int total=0,th=0;
   bool akhir=false;
   int op=-1;
   for(int cnt=0;cnt<OrdersTotal();cnt++)
     {
      if(!OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))continue;
      if(OrderSymbol()!=_Symbol)continue;
      if(OrderMagicNumber()!=magic_number_hedging)continue;
      th++;
     }
   ceks=ceks+"\n langkah "+(string)s;s++;

   for(int cnt=OrdersHistoryTotal()-1;cnt>=0;cnt--)
     {
      if(!OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY))continue;
      if(OrderSymbol()!=_Symbol)continue;
      double hop=OrderOpenPrice();
      double hcp=OrderClosePrice();
      double hpr=OrderProfit();
      string hrp=DoubleToStr(MathAbs(hop-hcp)/Point,2);
      int htk=OrderTicket();
      int t=OrderType(),tk=OrderTicket();

      string bs=t==0?" BUY":t==1?" SELL":" PO";
      //       "RESULT - GBP/USD SELL" "#353454353 - Result = 10 and 100 points"
      string hs=(hpr>0?" ":" -")+hrp+" and "+hrp+" Point";
      string hsub="RESULT - "+_Symbol+" "+bs+" ";
      string htex="#"+(string)tk+" - Result"+hs;

      if(OrderMagicNumber()==magic_number_hedging)
        {
         if(TimeToStr(OrderCloseTime(),TIME_DATE|TIME_MINUTES)==TimeToStr(Time[0],TIME_DATE|TIME_MINUTES))
            if(atik!=OrderTicket())
              {
               if(email_enabled) SendMail(hsub,htex);
               if(alert_enabled) Alert(_Symbol+" "+htex);
               atik=OrderTicket();
              }
         break;
        }
      if(OrderMagicNumber()==magic_number)
        {
         if(TimeToStr(OrderCloseTime(),TIME_DATE|TIME_MINUTES)==TimeToStr(Time[0],TIME_DATE|TIME_MINUTES))
            if(atik!=OrderTicket())
              {
               if(email_enabled) SendMail(hsub,htex);
               if(alert_enabled) Alert(_Symbol+" "+htex);
               atik=OrderTicket();
              }

         if(OrderClosePrice()!=OrderStopLoss()) break;//akhir=true;
         if(OrderClosePrice()==OrderStopLoss()) tlot=OrderLots();
         op=OrderType();
         //         akhir=true;
         TP=TP_2;SL=SL_2;
         if(TP2Order==1)
            TP=(MathAbs(OrderOpenPrice()-OrderStopLoss())/Point)*TP_2;
         if(SL2Order==1)
            SL=(MathAbs(OrderOpenPrice()-OrderStopLoss())/Point)*SL_2;
         break;
        }
     }
   ceks=ceks+"\n langkah op "+(string)op+" "+(string)s;s++;
   if(th>0)TPSL();
   if(op<0)return;
   color cor=op==0?clrBlue:clrRed;
   ceks=ceks+"\n langkah total "+(string)total+" "+(string)s;s++;
   //Print("total "+(string)total);
   //Print(cekdouble(total,LotHedging));
   if(Reverse_Direction)
   {
      Order_Type=1-op;
   }
   else
   {
      Order_Type=op;
   }
   if(delayhed())
      if(th==0) SendOrder(NULL,Order_Type,LotHed,
         //   cekdouble(total,LotHedging),
         0,max_slippage,0,0,"",magic_number_hedging,0,cor);
   ceks=ceks+"\n langkah "+(string)s;s++;
  }
double SL,TP;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void TPSL(bool reset=false)
  {
   RefreshRates();
   int ot=OrdersTotal();
   for(int i=0;i<ot;i++)
     {
      if(!OrderSelect(i,SELECT_BY_POS))continue;
      if(OrderSymbol()!=_Symbol)continue;
      if(OrderMagicNumber()!=magic_number_hedging)continue;
      int  tipe=OrderType();
      if(OrderType()!=tipe)continue;
        {

           {
            double   sl=OrderStopLoss();
            double tp=OrderTakeProfit();
            double buka=OrderOpenPrice();
              {
               int kons=1;double pr=Ask;
               if(tipe==1 || tipe==3 || tipe==5){ kons=-1;pr=Bid;}
               if(OrderStopLoss()==0)
               if(SL>0) {if(sl!=buka-(SL*Point*kons) || sl==0)sl=buka-(SL*Point*kons);}
               if(OrderTakeProfit()==0)
               if(TP>0) {if(tp!=buka+(TP*Point*kons) || tp==0) tp=buka+(TP*Point*kons);}
              }
            int tik=-1;
            if(NormalizeDouble(OrderStopLoss(),Digits)==NormalizeDouble(sl,Digits) && 
               NormalizeDouble(OrderTakeProfit(),Digits)==NormalizeDouble(tp,Digits))continue;
            tik=OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(sl,Digits),NormalizeDouble(tp,Digits),0,clrBlue);
            if(tik>0)continue;

           }
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnTick()
  {
   CutS();

//   Comment(ceks);
   ceks="";
   datetime t0 = StrToTime(day_start);
   datetime t1 = iTime(NULL,PERIOD_M1,0);
   datetime t3 = StrToTime(day_end);

   int day_start_int=(int)StringToInteger(day_start);
   int day_end_int=(int)StringToInteger(day_end);
   if(t1<=t3 && t1<t0 && day_start>(string)day_end_int)
     {
      t0-=86400;
     }
   else if(t3<t0)
     {
      //Print("t3 < t0");
      //t3+=86400;
     }

   bool newbar=IsNewBar(PERIOD_M1);
   if(ObjectFind(0,SDNAME(t0))>=0)
     {
      int t0_shift=iBarShift(NULL,PERIOD_M1,(datetime)ObjectGet(SDNAME(t0),OBJPROP_TIME1),false);
      if(newbar && t0_shift>1 && t1>t0 && t1<t3)
        {
         double spread=MarketInfo(NULL,MODE_SPREAD)*Point;
         double last_close=iClose(NULL,PERIOD_M1,1);
         double last_close1=iClose(NULL,PERIOD_M1,2);
         CArrayDouble *data=new CArrayDouble();
         for(int i=1;i<t0_shift;i++)
           {
            data.Add(iClose(NULL,PERIOD_M1,i));
           }
         double std_dev=standard_deviation(data);
         double close_prices[];
         ArrayCopySeries(close_prices,MODE_CLOSE,NULL,PERIOD_M1);
         double center=LRMA(1,t0_shift-1,close_prices);
         double upper = center+std_dev*std_deviation;
         double lower = center-std_dev*std_deviation;
         int result=0;
         if(std_dev>0 && IsOrderSendAllowed(t0_shift) && center>0)
           {
            if(last_close>upper && last_close1<upper)
              {
               if(Direction)
               {
                  Order_Type = OP_BUY;
               }
               else
               {
                  Order_Type = OP_SELL;
               }
               result=SendOrder(NULL,Order_Type,lotsize,0,max_slippage,0,0,"",magic_number,0,clrRed);
              }
            else if(last_close<lower && last_close1>lower)
              {
              if(Direction)
               {
                  Order_Type = OP_SELL;
               }
               else
               {
                  Order_Type = OP_BUY;
               }
               result=SendOrder(NULL,Order_Type,lotsize,0,max_slippage,0,0,"",magic_number,0,clrGreen);
              }
            if(result>0)
              {
               double sl=0,tp=0,tp_raw=0;
               //Print("time: "+iTime(NULL,PERIOD_M1,1)+" spread: "+spread+" std value: "+std_dev+" last close: "+last_close+" last close 1: "+last_close1+" upper: "+upper+" lower: "+lower+" center: "+center+" total: "+data.Total()+" t0_shift: "+t0_shift+" time at t0: "+iTime(NULL,PERIOD_M1,t0_shift));               
               last_ticket=result;
               int order_type=0;
               int order_ticket = 0;
               double open_price=0;
               if(takeprofit_mode>0 || stoploss_mode>0)
                 {

                  if(OrderSelect(result,SELECT_BY_TICKET))
                    {
                     order_type=OrderType();
                     open_price= OrderOpenPrice();
                     order_ticket=OrderTicket();
                     if(takeprofit_mode==TP_MODE_STD_PERCENT)
                       {
                        tp_raw=std_dev*std_deviation*(takeprofit_percent/100);
                        tp=NormalizeDouble(open_price+(order_type==OP_BUY?tp_raw:(-tp_raw)),Digits);
                       }
                     if(stoploss_mode==SL_MODE_TP)
                       {
                        sl=NormalizeDouble(open_price+(order_type==OP_BUY?(-(tp_raw+spread)):(tp_raw+spread)),Digits);
                       }
                     if(stoploss_mode==SL_MODE_STD)
                       {
                        if(order_type==OP_BUY)
                          {
                           sl=NormalizeDouble(center-std_dev*stoploss_deviation,Digits);
                          }
                        else if(order_type==OP_SELL)
                          {
                           sl=NormalizeDouble(center+std_dev*stoploss_deviation,Digits);
                          }
                       }
                     //double sl_value = MathAbs(open_price-sl);
                     //double tp_value = MathAbs(open_price-tp);
                     //int minimum_distance=(int)MarketInfo(NULL,MODE_STOPLEVEL);
                     //double tick_value_inv=MarketInfo(NULL,MODE_TICKSIZE);
                     //Print("first modification (raw): "+(string)open_price+" "+(string)sl+" "+(string)tp);
                     //sl = NormalizeDouble(MathRound(sl/tick_value_inv)*tick_value_inv,Digits);
                     //tp = NormalizeDouble(MathRound(tp/tick_value_inv)*tick_value_inv,Digits);
                     //Print("first modification: "+(string)open_price+" "+(string)sl+" "+(string)tp+" "+(string)tick_value_inv);
                     bool mod=false;
                     //if(sl_value*MathPow(10,Digits)>minimum_distance && tp_value*MathPow(10,Digits)>minimum_distance)
                        mod=OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,OrderExpiration());
                     //Print("sl and/or tp below minimumm distance.");
                     if(!mod)
                       {
                        //Print("Initial SL/TP failed, replacing with Secondary stops");

                        //sl = NormalizeDouble(open_price+Point*fallback_sl_mult*(order_type==OP_BUY?(-(minimum_distance+spread)):(minimum_distance+spread)),Digits);
                        //tp = NormalizeDouble(open_price+Point*fallback_tp_mult*(order_type==OP_BUY?(minimum_distance):(-minimum_distance)),Digits);
                        //Print("second modification (raw): "+(string)open_price+" "+(string)sl+" "+(string)tp);
                        //sl = NormalizeDouble(MathRound(sl/tick_value_inv)*tick_value_inv,Digits);
                        //tp = NormalizeDouble(MathRound(tp/tick_value_inv)*tick_value_inv,Digits);
                        //Print("second modification: "+(string)open_price+" "+(string)sl+" "+(string)tp);
                        if(order_type==OP_BUY)
                        {
                           sl = open_price - (open_price - sl)*secondary_sl_mult;
                           tp = open_price + (tp - open_price)*secondary_tp_mult;
                        }
                        else if(order_type==OP_SELL)
                        {
                           sl = open_price + (sl - open_price)*secondary_sl_mult;
                           tp = open_price - (open_price - tp)*secondary_tp_mult;
                        }  
                        mod = OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,OrderExpiration());
                        //if(!mod)
                           //Print("Second SL/TP modification failed: "+(string)GetLastError());
                       }
                    }
                  else Print("Error Selecting Order: "+(string)GetLastError());
                 }
               else Print("Error Sending Order: "+(string)GetLastError());
               if((email_enabled || alert_enabled) && result>0)
                 {
/*
for example:  "ORDER - EUR/USD BUY"
for example:  "#4834783483 - entry price = 100, SL = 98, TP = 102"
*/
                  string text="#"+(string)order_ticket+" - entry price = "+(string)DoubleToStr(OrderOpenPrice(),Digits)+
                              " SL = "+(string)DoubleToStr(sl/Point,1)+"  TP = "+(string)DoubleToStr(tp/Point,1);
                  if(email_enabled)
                     SendMail("ORDER - "+_Symbol+(order_type==0?" BUY":" SELL"),text);
                  if(alert_enabled)
                     Alert(_Symbol+" "+text);
                 }
              }
           }
         delete data;
        }
      if(t1<=t3)
         ObjectSetInteger(0,SDNAME(t0),OBJPROP_TIME2,t1);
     }
   else if(t3>t0 && t1>t0)
     {
      if(t1>t3)
         t1=t3;
      if(!ObjectCreate(0,SDNAME(t0),OBJ_STDDEVCHANNEL,0,t0,0,t1,0))
        {
         Print(__FUNCTION__,": failed to create standard deviation channel! Error code = ",GetLastError());
         return;
        }
      ObjectSetDouble(0,SDNAME(t0),OBJPROP_DEVIATION,std_deviation);
      ObjectSetInteger(0,SDNAME(t0),OBJPROP_COLOR,std_color);
      ObjectSetInteger(0,SDNAME(t0),OBJPROP_STYLE,std_style);
      ObjectSetInteger(0,SDNAME(t0),OBJPROP_WIDTH,std_width);
      ObjectSetInteger(0,SDNAME(t0),OBJPROP_BACK,std_back);
      
      //if(!ObjectCreate(0,obj_name,OBJ_STDDEVCHANNEL,0,t0,0,t1,0))
      //  {
      //   Print(__FUNCTION__,": failed to create standard deviation channel! Error code = ",GetLastError());
      //   return;
      //  }
      //ObjectSetDouble(0,obj_name,OBJPROP_DEVIATION,stoploss_deviation);
      //ObjectSetInteger(0,obj_name,OBJPROP_TIME2,t1);
      //ObjectSetInteger(0,obj_name,OBJPROP_COLOR,std_color);
      //ObjectSetInteger(0,obj_name,OBJPROP_STYLE,std_style);
      //ObjectSetInteger(0,obj_name,OBJPROP_WIDTH,std_width);
      //ObjectSetInteger(0,obj_name,OBJPROP_BACK,std_back);
      last_channel=SDNAME(t0);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool IsOrderSendAllowed(int shift)
  {
   if(shift<channel_min)
      return(false);
   if(last_ticket==0)
      return(true);
   else if(OrderSelect(last_ticket,SELECT_BY_TICKET))
     {
      datetime open_time=OrderOpenTime();
      datetime current=TimeCurrent();
      if(current-open_time<order_time_distance_min*60)
         return(false);
     }
   if(!delayhed())return false;
   return(true);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool delayhed()
  {
   int ot=OrdersHistoryTotal();
   for(int i=ot;i>=0;i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))continue;
      if(OrderSymbol()!=_Symbol)continue;
      if(OrderMagicNumber()!=magic_number_hedging)continue;
        {
         datetime open_time=OrderOpenTime();
         datetime current=TimeCurrent();
         if(current-open_time<order_time_distance_min*60)
            return(false);
        }
     }
   return(true);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool IsNewBar(int period=0)
  {
   static datetime current=0;
   datetime unformed=iTime(NULL,period,0);
   if(current==0 || unformed>current)
     {
      current=unformed;
      return(true);
     }
   return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int SendOrder(const string symbol,const int cmd,const double volume,const double entry,const int slippage,const double sl,const double tp,const string comment,const int magic,const datetime expiration,const color clr)
  {
   double price=0,stoploss=0,takeprofit=0;
   int type=OP_BUY;
   double point=MarketInfo(symbol,MODE_POINT);
   if(cmd==OP_BUY)
     {
      price=MarketInfo(symbol,MODE_ASK)+entry*point;
      stoploss=sl==0?0:price-sl*point;
      takeprofit=tp==0?0:price+tp*point;
      if(entry>0)
         type=OP_BUYSTOP;
      else if(entry<0)
         type=OP_BUYLIMIT;
      else type=cmd;
     }
   else if(cmd==OP_SELL)
     {
      price=MarketInfo(symbol,MODE_BID)+entry*point;
      stoploss=sl==0?0:price+sl*point;
      takeprofit=tp==0?0:price-tp*point;
      if(entry>0)
         type=OP_SELLLIMIT;
      else if(entry<0)
         type=OP_SELLSTOP;
      else type=cmd;
     }
   return OrderSend(symbol,type,volume,price,slippage,stoploss,takeprofit,comment,magic,expiration,clr);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double mean(CArrayDouble *data)
  {
   double sum=0;
   int total = data.Total();
   for(int i=0;i<total;i++)
     {
      sum+=data.At(i);
     }
   return(sum/total);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double median(CArrayDouble *data)
  {
   data.Sort();
   return(data.At((int)data.Total()/2));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double mode(CArrayDouble *data)
  {
   double ret = 0;
   double max = 0;
   CArrayDouble *num=new CArrayDouble();
   for(int a=0;a<40;a++)
      num.Add(0);
   for(int i=0;i<data.Total();i++)
     {
      double count=data.At(i);
      num.Update((int)count,num.At((int)count)+1);
     }
   double cumulative=0.0;
   for(int j=0;j<num.Total();j++)
     {
      double cnt=num.At(j);
      if(cnt>max)
        {
         max = cnt;
         ret = j;
        }
      cumulative+=cnt;
     }
   delete num;
   return(ret);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double variance(CArrayDouble *data)
  {
   double mean=mean(data);
   int total=data.Total();
   double sum=0;
   for(int i=0;i<total;i++)
     {
      double val=data.At(i)-mean;
      sum+=(val*val);
     }
   return(sum/total);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double covariance(CArrayDouble *data1,CArrayDouble *data2)
  {
   int n=MathMin(data1.Total(),data2.Total());
   double mean1=mean(data1);
   double mean2=mean(data1);
   double sum=0;
   for(int i=0;i<n;i++)
     {
      double val1=data1.At(i)-mean1;
      double val2=data2.At(i)-mean2;
      sum+=(val1*val2);
     }
   return(sum/(n-1));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double standard_deviation(CArrayDouble *data)
  {
   return(MathSqrt(variance(data)));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double bayes(CArrayDouble *data,int &possible[],int item)
  {
   return(0.0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double LRMA(const int pos,const int period,const double  &price[])
  {
   double Res=0;
   double tmpS=0,tmpW=0,wsum=0;;
   for(int i=0;i<period;i++)
     {
      tmpS+=price[pos+i];
      tmpW+=price[pos+i]*(period-i);
      wsum+=(period-i);
     }
   tmpS/=period;
   tmpW/=wsum;
   Res=3.0*tmpW-2.0*tmpS;

   return(Res);
  }
//+------------------------------------------------------------------+
int IntFromStr(string ValStr,int &M_Count,double &VMass[])
  {
   if(StringLen(ValStr)==0) return(-1);
   string SS=ValStr;
   int NP=0;
   string CS;
   M_Count=0;
   ArrayResize(VMass,M_Count);
   while(StringLen(SS)>0)
     {
      NP=StringFind(SS,",");
      if(NP>0)
        {
         CS=StringSubstr(SS,0,NP);
         SS=StringSubstr(SS,NP+1,StringLen(SS));
        }
      else
        {
         if(StringLen(SS)>0)
           {
            CS=SS;
            SS="";
           }
        }
      if(Str2Massive(CS,M_Count,VMass)==0)
        {
         return(-2);
        }
     }
   return(1);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int Str2Massive(string VStr,int &M_Count,double &VMass[])
  {
   double val=StrToDouble(VStr);
   if(val>0)
     {
      M_Count++;
      int mc=ArrayResize(VMass,M_Count);
      if(mc==0)return(-1);
      VMass[M_Count-1]=val;
      return(1);
     }
   else return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double cekdouble(int datai,string cek)
  {
   int C=0,m=0;
   if(IntFromStr(cek,C,lv)>1) { m=ArrayResize(lv,IntFromStr(cek,C,lv)); }
   if(datai>=ArraySize(lv))
     {//Print("Error M");
      return 0;
     }
   return(lv[datai]);
   return 0;
  }
//+------------------------------------------------------------------+
